 * PROGRAM - VENDOR LIST
* VERSION - 5.0
* DATE    - JUNE 2012
* AUTHOR - FRED H. HENCK
* EDIT AUTHOR(S) - PATSY PEPPERS
*********************************
* PRINTS THE VENDOR MASTER FILE *
*********************************
* Added active only option
********************************

#include "OIS.CH"
#include 'DCDIALOG.CH'
#include 'SET.CH'
#include 'XBP.CH'
#include 'APPEVENT.CH'
#include 'DCPICK.CH'
#include 'DCAPP.CH'
#include 'DCBITMAP.CH'
#include 'DCICON.CH'
#include "setcurs.ch"
#include "dcprint.ch"


PROCEDURE VENDORPO (XMENU)
//PROCEDURE TEST  (xmenu)
LOCAL GetList := {}, GetOptions, lStatus, oDialog, oDesc, oCancelButton, oScanButton
LOCAL  oPrinter, cScrn

VDCMPY=QCOMP

       COMPHOLD = 'TEST'

SetKey(K_F10,{||MEMVAR->nLastKey := -9, _Keyboard(CHR(K_CTRL_END))})
SetKey(K_F1,{||MEMVAR->nLastKey := 28, _Keyboard(CHR(K_CTRL_END))})

store .t. to activeonly
STORE .T. TO PRINTAGN

aSType:=  {{PADR("Alphabetical",20),'A'},;
             {PADR("Vendor Number",20),'B'}}

             aList:= DC_AConvert(aSTYPE)[1]
             cList:= DC_AConvert(aSTYPE)[2]
///THIS IS THE DEFAULT
   cStyp := "Alphabetical"

   CORRECT := 'A'

@ 01,01 DCSAY "Select Order" SAYSIZE 12 SAYRIGHTBOTTOM
@  1,15 DCCOMBOBOX TYPE XBPCOMBO_DROPDOWNLIST  cStyp LIST aLIST SIZE 20,3 ;
  ITEMSELECTED {||correct:=cList[ASCAN(aList,cStyp)],dc_getrefresh(getlist) }

@ 03,01 DCSAY "Active Only" SAYSIZE 12 SAYRIGHTBOTTOM

@ 03,15 dccheckbox activeonly






DCGETOPTIONS NORESIZE  TABSTOP   ;
   CHECKGET ;
   NOESCAPEKEY ;
   TITLE 'Vendor Master File' ;

DCREAD GUI ;
         TO lStatus ;
         ENTEREXIT ;
         ;                                      // MODAL ;
         OPTIONS GetOptions ;
         fit ;
         APPWINDOW oMainDialog:drawingArea ;
         NODESTROY ;
         ADDBUTTONS;
         PARENT @oDialog ;
         ;                                      // SAVE

IF !lStatus
   oDialog:destroy()
   oDialog := NIL
   CLOSE ALL
   RETURN
// EXIT
ENDIF

***file is then created in progam

**
     oDialog:destroy()
   oDialog := NIL

do Printready
 CLOSE ALL
return

*

Static Function PrintReady
         do while .t.
IF !Print_Choice( 'vendorpo', 1, '                         ', .f. )
  RETURN nil
ENDIF

do printjob
   enddo
RETURN nil



STATIC FUNCTION PrintJob()

LOCAL counter, page, cScrn, oPrinter
      IF !PrintOn('vendorpo',@oPrinter)
  RETURN nil
ENDIF

   STORE "10.Arial Bold" TO BOLDFONT
   Store "9.Arial" to Stdfont


IF Valtype(oPrinter) # 'O' .OR. !oPrinter:lActive
  RETURN nil
ENDIF
  DO CASE
      CASE CORRECT == 'A'
         USE APMSTRFL ORDER NAMEORDR

 CASE CORRECT = 'B'
         USE APMSTRFL ORDER APMSTRFL

ENDCASE
if activeonly
   set filter to vendinact<>.t.
endif
goto top

STORE SPACE(5) TO HOLDNO
STORE space(40) TO HOLDNAME
STORE space(40) TO HOLDADD1
STORE space(40) TO HOLDADD2
STORE SPACE(20) TO HOLDCITY
STORE '  ' TO HOLDSTATE
STORE SPACE(10) TO HOLDZIP
STORE SPACE(20) TO HOLDCONT
STORE SPACE(13) TO HOLDPHONE
STORE SPACE(13) TO HOLDFAX
store 0 to holdacct

 STORE .F. TO SINGLE
STORE 0 TO TSHPR

STORE 100 TO COUNTER
STORE 1 TO PAGE
 DO WHILE .NOT. EOF() .AND. DC_PRINTEROK(OPRINTER)
      IF COUNTER > 54
         IF COUNTER <>100
         dcprint eject printer oprinter
         ENDIF
       Dcprint font "&BOLDFONT"

        @ 00,00 dcprint say "Report:  VENDORPO"   PRINTER oPrinter
         @ 00,18 dcprint say dtox(DATE())   PRINTER oPrinter
         @ 00,30 dcprint say TIME()   PRINTER oPrinter
            IF VDCMPY <> ' '
            @ 01,40 dcprint say RTRIM(COMPHOLD)     PRINTER oPrinter  ALIGN DCPRINT_ALIGN_HCENTER
            ENDIF
            if activeonly
         @ 2,40 dcprint say "ACTIVE VENDOR LIST"   PRINTER oPrinter    ALIGN DCPRINT_ALIGN_HCENTER
            else
         @ 2,40 dcprint say "VENDOR LIST"   PRINTER oPrinter    ALIGN DCPRINT_ALIGN_HCENTER
            endif


         @ 02,71 dcprint say "PAGE"   PRINTER oPrinter
         @ 02,76 dcprint say PAGE PICTURE '9999'   PRINTER oPrinter

          @ 3,0 dcprint say REPLICATE(CHR(220),125)   PRINTER oPrinter

      STORE 4 TO COUNTER
      STORE PAGE+1 TO PAGE
      ENDIF
    Dcprint font "&Stdfont"

         IF HOLDNO = SPACE(5)
         STORE NUMBER TO HOLDNO
         STORE NAME TO HOLDNAME
         STORE ADDRESS TO HOLDADD1
         STORE BOX TO HOLDADD2
         STORE CITY TO HOLDCITY
         STORE STATE TO HOLDSTATE
         STORE ZIP TO HOLDZIP
         STORE CONTACT TO HOLDCONT
         STORE PHONE TO HOLDPHONE
         STORE FAX TO HOLDFAX
         store defaccount to holdacct
         store account to vendacct
         TSHPR = TSHPR+1
         ELSE
         @ COUNTER,5 dcprint say  HOLDNO    PRINTER oPrinter   ALIGN DCPRINT_ALIGN_RIGHT
         @ COUNTER,7 dcprint say SUBSTR(HOLDNAME,1,32)   PRINTER oPrinter
         @ COUNTER,39 dcprint say ":"   PRINTER oPrinter
         @ COUNTER,46 dcprint say NUMBER PICTURE '999999'   PRINTER oPrinter   ALIGN DCPRINT_ALIGN_RIGHT
         @ COUNTER,48 dcprint say SUBSTR(NAME,1,32)   PRINTER oPrinter
           IF SINGLE<>.T.
         COUNTER = COUNTER+1
         @ COUNTER,0 dcprint say substr(HOLDADD1,1,38)   PRINTER oPrinter
         @ COUNTER,39 dcprint say ":"   PRINTER oPrinter

         @ COUNTER,41 dcprint say substr(ADDRESS,1,38)   PRINTER oPrinter
         COUNTER = COUNTER+1
         @ COUNTER,0  dcprint say substr(HOLDADD2,1,38)   PRINTER oPrinter
         @ COUNTER,39 dcprint say ":"   PRINTER oPrinter

         @ COUNTER,41 dcprint say substr(BOX,1,38)   PRINTER oPrinter
         COUNTER = COUNTER+1
         @ COUNTER,0  dcprint say HOLDCITY   PRINTER oPrinter
         @ COUNTER,25 dcprint say HOLDSTATE   PRINTER oPrinter
         @ COUNTER,38 dcprint say HOLDZIP PICTURE '99999-99999'   PRINTER oPrinter  ALIGN DCPRINT_ALIGN_RIGHT
         @ COUNTER,39 dcprint say ":"   PRINTER oPrinter
         @ COUNTER,41 dcprint say CITY   PRINTER oPrinter
         @ COUNTER,66 dcprint say STATE   PRINTER oPrinter
         @ COUNTER,79 dcprint say ZIP PICTURE '99999-99999'   PRINTER oPrinter  ALIGN DCPRINT_ALIGN_RIGHT
         COUNTER = COUNTER+1
         @ COUNTER,0 dcprint say 'ACCOUNT# '+VENDACCT   PRINTER oPrinter
         @ COUNTER,39 dcprint say ":"   PRINTER oPrinter
         @ COUNTER,41 dcprint say 'ACCOUNT# '+ACCOUNT   PRINTER oPrinter
         COUNTER = COUNTER+1
         @ COUNTER,0 dcprint say SUBSTR(HOLDCONT,1,24)   PRINTER oPrinter
         @ COUNTER,25 dcprint say HOLDPHONE PICTURE '(999)999-9999'   PRINTER oPrinter
         @ COUNTER,39 dcprint say ":"   PRINTER oPrinter
         @ COUNTER,41 dcprint say SUBSTR(CONTACT,1,24)   PRINTER oPrinter
         @ COUNTER,66 dcprint say PHONE PICTURE '(999)999-9999'   PRINTER oPrinter
         COUNTER=COUNTER+1
         @ COUNTER,00 DCPRINT SAY "ACCOUNT"
         @ COUNTER,14 dcprint say HOLDACCT PICTURE '999999'   PRINTER oPrinter ALIGN DCPRINT_ALIGN_RIGHT
         @ COUNTER, 20 DCPRINT SAY "FAX"
         @ COUNTER,25 dcprint say HOLDFAX PICTURE '(999)999-9999'   PRINTER oPrinter
         @ COUNTER,39 dcprint say ":"   PRINTER oPrinter
         @ COUNTER,41 DCPRINT SAY "ACCOUNT"
         @ COUNTER,55 dcprint say DEFACCOUNT PICTURE '999999'   PRINTER oPrinter ALIGN DCPRINT_ALIGN_RIGHT
         @ COUNTER,61 DCPRINT SAY "FAX"
         @ COUNTER,66 dcprint say FAX PICTURE '(999)999-9999'   PRINTER oPrinter

           ENDIF
         TSHPR = TSHPR+1
         COUNTER = COUNTER+1
         STORE SPACE(5) TO HOLDNO
         STORE SPACE(40) TO HOLDNAME
         STORE SPACE(40) TO HOLDADD1
         STORE SPACE(40) TO HOLDADD2
         STORE SPACE(20) TO HOLDCITY
         STORE '  ' TO HOLDSTATE
         STORE SPACE(10) TO HOLDZIP
         STORE SPACE(36) TO HOLDCONT
         STORE SPACE(13) TO HOLDPHONE
         STORE 0 TO HOLDACCT
         IF !SINGLE
         @ COUNTER,0 dcprint say REPLICATE("-",80)   PRINTER oPrinter   FIXED
         COUNTER = COUNTER+1
         ENDIF
         ENDIF
      SKIP
      ENDDO
         IF HOLDNO <> SPACE(5)
           IF COUNTER > 54

         IF COUNTER <>100
         dcprint eject printer oprinter
         ENDIF
          Dcprint font "&BOLDFONT"

        @ 00,00 dcprint say "Report:  VENDORPO"   PRINTER oPrinter
         @ 00,18 dcprint say dtox(DATE())   PRINTER oPrinter
         @ 00,30 dcprint say TIME()   PRINTER oPrinter
            IF VDCMPY <> ' '
            @ 01,40 dcprint say RTRIM(COMPHOLD)     PRINTER oPrinter  ALIGN DCPRINT_ALIGN_HCENTER

            ENDIF
         @ 2,40 dcprint say "VENDOR LIST"   PRINTER oPrinter    ALIGN DCPRINT_ALIGN_HCENTER

         @ 02,71 dcprint say "PAGE"   PRINTER oPrinter
         @ 02,76 dcprint say PAGE PICTURE '9999'   PRINTER oPrinter

          @ 3,0 dcprint say REPLICATE(CHR(220),125)   PRINTER oPrinter

           STORE 4 TO COUNTER
           STORE PAGE+1 TO PAGE
           ENDIF
     Dcprint font "&Stdfont"

         @ COUNTER,5 dcprint say  HOLDNO    PRINTER oPrinter   ALIGN DCPRINT_ALIGN_RIGHT
         @ COUNTER,7 dcprint say SUBSTR(HOLDNAME,1,32)   PRINTER oPrinter
         COUNTER = COUNTER+1
         @ COUNTER,0 dcprint say HOLDADD1   PRINTER oPrinter
         COUNTER = COUNTER+1
         @ COUNTER,0  dcprint say HOLDADD2   PRINTER oPrinter
         COUNTER = COUNTER+1
         @ COUNTER,0  dcprint say HOLDCITY   PRINTER oPrinter
         @ COUNTER,25 dcprint say HOLDSTATE   PRINTER oPrinter
         @ COUNTER,38 dcprint say HOLDZIP PICTURE '99999-99999'   PRINTER oPrinter  ALIGN DCPRINT_ALIGN_RIGHT
         COUNTER = COUNTER+1
         @ COUNTER,0 dcprint say SUBSTR(HOLDCONT,1,24)   PRINTER oPrinter
         @ COUNTER,25 dcprint say HOLDPHONE PICTURE '(999)999-9999'   PRINTER oPrinter
          COUNTER=COUNTER+1
         @ COUNTER,00 DCPRINT SAY "ACCOUNT"
         @ COUNTER,14 dcprint say HOLDACCT PICTURE '999999'   PRINTER oPrinter ALIGN DCPRINT_ALIGN_RIGHT

           @ COUNTER, 20 DCPRINT SAY "FAX"
          @ COUNTER,25 dcprint say HOLDFAX PICTURE '(999)999-9999'   PRINTER oPrinter


         COUNTER = COUNTER+2
         ENDIF
COUNTER = COUNTER+1
Dcprint font "&BOLDFONT"
@ COUNTER,14 dcprint say TSHPR PICTURE '99999'   PRINTER oPrinter   ALIGN DCPRINT_ALIGN_RIGHT
@ COUNTER,17 dcprint say "TOTAL VENDORS"   PRINTER oPrinter
Dcprint font "&Stdfont"


PRINTOFF(OPRINTER)

RETURN nil

