 * PROGRAM - PRINT OPTION CHOICES
* VERSION - 5.0
* DATE    - Sept 2013
 * AUTHOR - FRED H. HENCK
* EDIT AUTHOR(S) - PATSY PEPPERS
**********************************************
* Print options called for all print jobs    *
**********************************************
#INCLUDE "dcdialog.CH"
#INCLUDE "dcprint.CH"
#INCLUDE "common.CH"
#INCLUDE "ois.CH"
*********************************************
**********  Printer Definitions  ************
*********************************************
#define PRN_MODE                1
#define PRN_ORIENTATION         2
#define PRN_OUTFILE             3
#define PRN_TEXTONLY            4
#define PRN_USEDEFAULT          5
#define PRN_FONT                6
#define PRN_TEMPFILE            7
#define PRN_EMAILTO             9
#define PRN_EMAILMEMO           10
#define PRN_WIDTH               11
#define PRN_LMARGIN             12
#define PRN_RMARGIN             13
#define PRN_START_ROW           14
#define PRN_COVER               15
#define PRN_DBL_SPACE           16
#define PRN_TITLE               17
#define PRN_COPIES              18
#define PRN_EMAIL               19

#DEFINE CRLF  Chr(13)+Chr(10)

STATIC saPrintOptions[20]



//#define SENDMAIL_ASINET
#define SENDMAIL_MARSHALLSOFT



#ifdef SENDMAIL_MARSHALLSOFT

  #include "dll.ch"
  #include "see32.ch"
  #include "keycode.ch"

#endif
* -----------------

FUNCTION Print_Loop( cTitle, nCopies, lEmail, bEval )

LOCAL nExit

DEFAULT lEmail := .F.

IF lEmail
  IF Print_Choice( cTitle, nCopies, .T., .F.  )
    Eval( bEval )
  ENDIF
ELSE
  DO WHILE .T.
    nExit := Print_Choice( cTitle, nCopies, lEmail, TRUE )
    IF Empty(nExit)
      EXIT
    ENDIF
    Eval( bEval )
    IF Valtype(nExit) = 'N'
      IF nExit = 1
        EXIT
      ENDIF
    ELSE
      EXIT
    ENDIF
  ENDDO
ENDIF

RETURN .T.

// *************************************************
//  Function: Print_Choice
//  Purpose: Asks if user wants a printed copy of
//           the current form.
//
//  Returns: TRUE if yes, FALSE if no.
//
// *************************************************

FUNCTION Print_Choice( cTitle, nCopies, cEmail, lLoop)

LOCAL GetList[0], GetOptions, lStatus, oPrintModeGroup, oPrintLayoutGroup, ;
      oPrintEmailGroup, oPrintFileGroup, nExit := 0, aButtons, aFonts, ;
      oFileFormatGroup



DEFAULT lLoop := .F.
pdfinstall := .f.
aFonts := { ;
  '11.Courier New', ;
  '11.Courier New Bold', ;
  '11.Lucida Console', ;
  '11.Lucida Console Bold', ;
  '11.Terminal' , ;
  '11.Terminal Bold' }

ClearPrintVars()

nSaveArea := Select()

DEFAULT cEmail := Space(100)


saPrintOptions[PRN_ORIENTATION] := 1   //to reset default
if ncopies=2
saPrintOptions[PRN_ORIENTATION] := 2
ncopies=1
endif
if ncopies=3
saPrintOptions[PRN_ORIENTATION] := 3
ncopies=1
endif


noemail=.t.
setemail=.f.

SELE (nSaveArea)

saPrintOptions[PRN_EMAILTO] := cEmail

DEFAULT saPrintOptions := {}
ASize(saPrintOptions,20)

saPrintOptions[PRN_COPIES] := nCopies

DEFAULT saPrintOptions[PRN_MODE] := 4, ;
        saPrintOptions[PRN_ORIENTATION] := 1, ;
        saPrintOptions[PRN_OUTFILE] := '', ;
        saPrintOptions[PRN_TEXTONLY] := .T., ;
        saPrintOptions[PRN_EMAIL] := .F., ;
        saPrintOptions[PRN_EMAILMEMO] := '', ;
        saPrintOptions[PRN_FONT] := '11.Lucida Console Bold', ;
        saPrintOptions[PRN_COPIES] := 1

saPrintOptions[PRN_OUTFILE] := Pad(saPrintOptions[PRN_OUTFILE],45)
saPrintOptions[PRN_EMAILTO] := Pad(saPrintOptions[PRN_EMAILTO],100)
saPrintOptions[PRN_FONT] := Pad(saPrintOptions[PRN_FONT],30)


        if (AScan(XbpPrinter():new():list(),{|c|Upper(c)=='WIN2PDF'})>0 .OR. ;
               AScan(XbpPrinter():new():list(),{|c|Upper(c)=='BULLZIP PDF PRINTER'})>0)

               saPrintOptions[PRN_TEXTONLY] := .f.

        endif




@ 0,0 DCSAY 'Select Output Mode' SAYSIZE 65 SAYCENTER FONT '11.Arial Bold'
@ 1,0 DCSTATIC TYPE XBPSTATIC_TYPE_RAISEDBOX SIZE 65, .1

* ------- Mode Group -------- *

@ 2,0 DCGROUP oPrintModeGroup CAPTION 'Print Mode' SIZE 65,4.5

@ 1,2 DCRADIO saPrintOptions[PRN_MODE] VALUE 1 PROMPT 'Normal Preview' ;
      TOOLTIP 'Preview with built-in Preview Window' ;
      PARENT oPrintModeGroup ;
      ACTION {||saPrintOptions[PRN_EMAIL] := .F. }

@ 2,2 DCRADIO saPrintOptions[PRN_MODE] VALUE 2 PROMPT 'Preview w/Acrobat' ;
      TOOLTIP 'Preview with Acrobat Reader;Requires Bullzip PDF driver or Win2PDF driver and Acrobat Installed ' ;
      PARENT oPrintModeGroup ;
      ACTION {||saPrintOptions[PRN_TEXTONLY] := .F., ;
                saPrintOptions[PRN_EMAIL] := .F., ;
                DC_GetRefresh(GetList)} ;
      WHEN {||AScan(XbpPrinter():new():list(),{|c|Upper(c)=='WIN2PDF'})>0 .OR. ;
              AScan(XbpPrinter():new():list(),{|c|Upper(c)=='BULLZIP PDF PRINTER'})>0} ;



@ 1,25 DCRADIO saPrintOptions[PRN_MODE] VALUE 3 PROMPT 'Selected Printer' ;
      TOOLTIP 'Print to any installed printer device;Select a printer from standard dialog' ;
      PARENT oPrintModeGroup ;
      ACTION {||saPrintOptions[PRN_EMAIL] := .F. }

@ 2,25 DCRADIO saPrintOptions[PRN_MODE] VALUE 4 PROMPT 'Default Printer' ;
      TOOLTIP 'Print to the default printer device' ;
      PARENT oPrintModeGroup ;
      ACTION {||saPrintOptions[PRN_EMAIL] := .F. }

@ 1,47 DCRADIO saPrintOptions[PRN_MODE] VALUE 5 PROMPT 'Send to File' ;
      TOOLTIP 'Create a File for emailing or Export' ;
      PARENT oPrintModeGroup ;
      ACTION {||saPrintOptions[PRN_EMAIL] := .F. }

@ 2,47 DCRADIO saPrintOptions[PRN_MODE] VALUE 6 PROMPT 'Send by Email' ;
      When { ||noemail=.f. } ;
      TOOLTIP 'Create a File for emailing or Export' ;
      PARENT oPrintModeGroup ;
      ACTION {|a,b,o|IIF(saPrintOptions[PRN_MODE]=6, ;
                        saPrintOptions[PRN_EMAIL]:=.t., nil), ;
                        DC_GetRefresh(GetList)}



                        //turn off 10/2006
                        /*
//@ 3,47 dccheckbox setemail prompt "Set Up Email" ;
//PARENT oPrintModeGroup ;
//hide { ||noemail=.f. } ;
//Action { ||Upemail(getlist) }
                          */


* ------- File Format Group -------- *

@ 7,0 DCGROUP oFileFormatGroup CAPTION 'File Format' SIZE 65,4

@ 1,2 DCRADIO saPrintOptions[PRN_TEXTONLY] VALUE .T. PROMPT 'Text (.TXT)' ;
      PARENT oFileFormatGroup WHEN {||saPrintOptions[PRN_MODE] $ {5,6} }

@ 1,22 DCRADIO saPrintOptions[PRN_TEXTONLY] VALUE .F. PROMPT 'Acrobat (.PDF)' ;
      PARENT oFileFormatGroup WHEN {||saPrintOptions[PRN_MODE] $ {5,6} ;
        .AND. (AScan(XbpPrinter():new():list(),{|c|Upper(c)=='WIN2PDF'})>0 .OR. ;
               AScan(XbpPrinter():new():list(),{|c|Upper(c)=='BULLZIP PDF PRINTER'})>0) }



/*
@ 1,42 dccheckbox pdfinstall prompt "Win2pdf Installation" ;
  PARENT oFileFormatGroup ;
Hide {||AScan(XbpPrinter():new():list(),{|c|Upper(c)=='WIN2PDF'})>0} ;
Action { ||loadpdf(getlist) }
  */


@ 2.5,2 DCSAY "Output File" GET saPrintOptions[PRN_OUTFILE] ;
      SAYSIZE 0 SAYBOTTOM ;
      PARENT oFileFormatGroup ;
      WHEN {||saPrintOptions[PRN_MODE] $ {5,8} }

* ------- Email Group -------- *

@12,0 DCGROUP oPrintEmailGroup CAPTION 'Email' SIZE 65,9

@ 1,2 DCSAY 'Email Address:' SAYSIZE 0 PARENT oPrintEmailGroup

@ 2,2 DCGET saPrintOptions[PRN_EMAILTO] PARENT oPrintEmailGroup  PICTURE '@S50';
      WHEN {||saPrintOptions[PRN_MODE]=6}

@ 3,2 dcsay "Use ';' to Separate Email Addresses. Email will Expand" font '8.Arial Bold' ;
      PARENT oPrintEmailGroup ;
      Hide {||saPrintOptions[PRN_MODE]<>6}

@ 4,2 DCSAY 'Email Memo:' SAYSIZE 0 PARENT oPrintEmailGroup

@ 5,2 DCMULTILINE saPrintOptions[PRN_EMAILMEMO] SIZE 60,3 ;
      PARENT oPrintEmailGroup ;
      WHEN {||saPrintOptions[PRN_MODE]=6}

 IF lLoop
   //see acctanal.tst for options concerning using the 3-buttons,works with that set up
   //but we decided to use the ok/cancel buttons c:\oiswin\acctanal.tst

  @ 23,01 DCPUSHBUTTON CAPTION 'Print and Exit' ;
          ACTION {||nExit := 1, DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
          SIZE 15,1.2 ;
          ID 'DCGUI_BUTTON_OK' ;
          TOOLTIP 'Print this job using selected parameters and exit'

  @ 23,20 DCPUSHBUTTON CAPTION 'Print and Loop' ;
          ACTION {||nExit := 2, DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
          SIZE 15,1.2 ;
          TOOLTIP 'Print this job using selected parameters, then redisplay;' + ;
                  'this dialog window to print the job again using different;' + ;
                  'parameters.'

  @ 23,39 DCPUSHBUTTON CAPTION 'Cancel' ;
          ACTION {||nExit := 0, DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)} ;
          SIZE 15,1.2

ENDIF

DCGETOPTIONS ;
   NOMINBUTTON ;
   NOMAXBUTTON ;
   BUTTONALIGN DCGUI_BUTTONALIGN_CENTER ;
   TABSTOP ;
   BUTTONS aButtons ;


DCREAD GUI ;
   FIT ;
   _ADDBUTTONS !lLoop ;
   TITLE 'Printer Options' ;
   OPTIONS GetOptions ;
   MODAL ;
   SETAPPWINDOW ;
   TO lStatus ;
   SETFOCUS 'DCGUI_BUTTON_OK'

IF lStatus
  saPrintOptions[PRN_TITLE] := cTitle
ENDIF



saPrintOptions[PRN_FONT] := Alltrim(saPrintOptions[PRN_FONT])

IF lLoop
  RETURN nExit
ENDIF

RETURN lStatus

* --------------

STATIC FUNCTION ClearPrintVars( GetList )

saPrintOptions[PRN_OUTFILE] := Space(45)
saPrintOptions[PRN_EMAILTO] := Space(45)
saPrintOptions[PRN_EMAILMEMO] := ''

IF Valtype(GetList) = 'A'
  DC_GetRefresh(GetList)
ENDIF

RETURN nil

// **********************************************************
//  Function: PrintOn( cTitle, @oPrinter )
//  Purpose:  Sets the printer startup parameters
//
//  Params:   cTitle: The title of the Print Job
//
//  Returns:  aPointer to the DC_Printer() object.
// *************************************************************

FUNCTION PrintOn( cTitle, oPrinter, nOrientation, cFont, nCopies)

LOCAL cPrinterName, cFileName, nPointSize, nRows, nCols

// Characters not allowed in file names.
LOCAL aBadChars := {"/", "\", ":", "*", "?", '"', "<", ">", "|"}
LOCAL aMessage, lStatus

DEFAULT nOrientation := saPrintOptions[PRN_ORIENTATION]
DEFAULT cFont := saPrintOptions[PRN_FONT]
DEFAULT nCopies := saPrintOptions[PRN_COPIES]
DEFAULT cTitle := 'Print_Job'


//remarked out because i do not see what it does 8/2006
/*DO WHILE Valtype(DC_PrinterObject()) = 'O'

  aMessage := {'The system does not allow more than one', ;
               'print job to be run simultaneously.', ;
               'Please wait for the current job to finish.', ;
               '', ;
               'Retry?' }

  lStatus := YesNoBox('Print Job Warning','Print Job Warning',aMessage,50)
  IF !lStatus
    RETURN .F.
  ENDIF
//test exit here to see what is going on
  exit
ENDDO */

IF Empty(cFont)
  cFont := '11.Courier New'
ENDIF

//nPointSize := Val(cFont)

// Get print row/column grid geometry w.r.t. page orientation and
// current body font point size.
//if nOrientation = 1     // portrait ------
//  nRows := Round(726/nPointSize,0)    // 60*11.Courier
//  nCols := Round(880/nPointSize,0)    // 80*11.Courier
//else                                   // landscape ------
//  nRows := Round( 510/nPointSize,0)   // ((8.5/11)*660)*11.Courier
//  nCols := Round(1139/nPointSize,0)   // ((11/8.5)*880)*11.Courier
//endif

// Process output device names (for print to file and email).
cFileName := alltrim(saPrintOptions[PRN_OUTFILE])

IF AScan(XbpPrinter():new():list(),{|c|Upper(c)=='BULLZIP PDF PRINTER'}) > 0
  cPDFDriver := 'Bullzip PDF Printer'

ELSE
  cPDFDriver := 'Win2PDF'

ENDIF


if saPrintOptions[PRN_MODE] $ {2,6} .and. !saPrintOptions[PRN_TEXTONLY]
  cPrinterName := cPDFDriver
  //add datetime to printfile
  ctitle2=alltrim(ctitle)+"_"+dtos(date())+substr(time(),1,2)+substr(time(),4,2)
  saPrintOptions[PRN_TEMPFILE] := Alltrim(Strtran(cTitle2,' ','')) + '.PDF'
  cFileName := saPrintOptions[PRN_TEMPFILE]

  if file(cfilename)
        erase &cfilename
  endif

endif



if !Empty(saPrintOptions[PRN_OUTFILE]) .AND. !saPrintOptions[PRN_TEXTONLY]
  cPrinterName := cPDFDriver

elseif !Empty(saPrintOptions[PRN_EMAILTO]) .AND. saPrintOptions[PRN_MODE] = 6
  IF saPrintOptions[PRN_TEXTONLY]
    cPrinterName := 'TextFile'
    ctitle2=alltrim(ctitle)+"_"+dtos(date())+substr(time(),1,2)+substr(time(),4,2)
    saPrintOptions[PRN_TEMPFILE] := Alltrim(Strtran(cTitle2,' ','')) + '.TXT'
  ELSE
    cPrintername := cPDFDriver

    saPrintOptions[PRN_TEMPFILE] := Alltrim(Strtran(cTitle,' ','')) + '.PDF'
  ENDIF
  AEval(aBadChars, ;   // make sure we have a legal file name
            {|e|saPrintOptions[PRN_TEMPFILE] := StrTran(saPrintOptions[PRN_TEMPFILE],e,"-")})
  cFileName := saPrintOptions[PRN_TEMPFILE]

endif


//xls
if !Empty(saPrintOptions[PRN_OUTFILE])  .AND. saPrintOptions[PRN_MODE] = 8
   lXLS= at('XLS',Upper(saPrintOptions[PRN_OUTFILE]))
   if lxls=0
    saPrintOptions[PRN_OUTFILE] := alltrim(saPrintOptions[PRN_OUTFILE]) + '.xls'
    cFileName := saPrintOptions[PRN_OUTFILE]
   endif



endif



zfactor=1.6
nMargin=0
   if saPrintOptions[PRN_MODE] $ {2,5,6,8}
      nMargin=0
   else

   nMargin=3
   endif
   if saPrintOptions[PRN_MODE] $ {8}

nPointSize := Val(cFont)
     if nOrientation = 1     // portrait ------
  nRows := Round(726/nPointSize,0)    // 60*11.Courier
  nCols := Round(880/nPointSize,0)    // 80*11.Courier
else                                   // landscape ------
  nRows := Round( 510/nPointSize,0)   // ((8.5/11)*660)*11.Courier
  nCols := Round(1139/nPointSize,0)   // ((11/8.5)*880)*11.Courier
endif

   else
 IF NORIENTATION=1
   NROWS=60
   NCOLS=84
   CFONT='9.Arial'
 ELSE
IF NORIENTATION=2
   NROWS=44
   NCOLS=150  //TEST FOR EXCEL
   CFONT='8.Arial'
   zfactor=1.4
else
   NROWS=60
   NCOLS=132
   CFONT='7.Arial'
   NORIENTATION=1
endif

 ENDIF
   endif


    //IF NO FOLDER ADD vDRIVE+\OISWIN\ TO FILE NAME
   IF !EMPTY(CFILENAME) .and. substr(cfilename,1,2)<>'\\'
      store CFILENAME to xxtext
    nStart := at( "\", xxtext )
    if nstart=0
        store alltrim(subdef)+'\'+ALLTRIM(CFILENAME) TO CFILENAME
      //STORE vDRIVE+'\OISWIN\'+ALLTRIM(CFILENAME) TO CFILENAME  //changed to use subdef 10/2011
    endif
    if substr(cfilename,2,1)<>":"
        store vdrive+cfilename to cfilename
    endif
   ENDIF
store cfilename to saPrintOptions[PRN_TEMPFILE]
///dc_winalert(cfilename)


//dc_winalert(cfilename)
///trying to control cancelenable, which is causing problems

DCPRINT ON ;
  TO           oPrinter ;
  TITLE        "Print Job: " + Alltrim(cTitle) ;
  NAME         cPrinterName ;
  _TEXTONLY    saPrintOptions[PRN_TEXTONLY] .AND. saPrintOptions[PRN_MODE] $ {5,6};
  _PREVIEW     saPrintOptions[PRN_MODE] = 1 ;
  ; //PSIZE 600, 800 ;
  ZOOMFACTOR 1.6 ;
  Margin nMargin  ;
  BUTTONS ABUTTONS FINDBUTTON  ;
  _ACROBAT     saPrintOptions[PRN_MODE] = 2 ;
  _EXCEL       saPrintOptions[PRN_MODE] = 8 ;
  _TOFILE      !Empty(cFileName) ;
  OUTFILE      (cFileName) ;
   NOSTOP   BUSYMESSAGE "Please Wait............." ;
  _HIDE        saPrintOptions[PRN_MODE] = 1 ;
  ORIENTATION  nOrientation ;
  SIZE         nRows, nCols ;
  FONT         Alltrim(cFont) ;
  _USEDEFAULT  saPrintOptions[PRN_MODE] = 4 ;
  COPIES       nCopies ;
  COMBINEEXCELSHEETS ;
  Cancelenable


  if saPrintOptions[PRN_MODE]=2
   keyin=inkey(2)
  endif




  //if saPrintOptions[PRN_MODE] = 1
 // oPrinter:odlg:setFrameState(XBPDLG_FRAMESTAT_MAXIMIZED)
  //endif




return (valtype(oPrinter)=="O" .AND. oPrinter:lactive)

* ---------------

// **********************************************************
//  Function: PrintOff( oPrinter )
//  Purpose:  Turns off the print job and spools output
//
//  Params:   oPrinter: The Printer object returned by PrintOn()
//
//  Returns:  aPointer to the DC_Printer() object.
// **********************************************************

FUNCTION PrintOff( oPrinter, cTitle )

LOCAL cErrorText, lStatus, lSendMail, cText, cAttachment, cHeading, ;
      cMemo


DEFAULT cTitle := saPrintOptions[PRN_TITLE]

// Resolve function arguments.
iif(!Valtype(oPrinter)=="O", oPrinter := DC_PrinterObject(),)




lSendMail := !Empty(saPrintOptions[PRN_TEMPFILE])  .AND. ;
             saPrintOptions[PRN_MODE] = 6





lStatus := DC_PrinterOxx(oPrinter,,saPrintOptions[PRN_MODE] # 1)

/*
if lstatus
dc_winalert("LSTATUS")
else
dc_winalert("NOT LSTATUS")
endif
  */
if oprinter:lterminated .and. saPrintOptions[PRN_MODE] <> 1
        dc_msgbox(,,{"Print Job Terminated"},,,5)
else



 if saPrintOptions[PRN_MODE] =3 .or.  saPrintOptions[PRN_MODE] = 4
   dc_msgbox(,,{"Print Job Completed"},,,5)
 endif

  if saPrintOptions[PRN_MODE]=2
   keyin=inkey(2)
  endif



// Handle email report request.
if lSendMail .AND. lStatus

if !Empty(saPrintOptions[PRN_OUTFILE]) .AND. !saPrintOptions[PRN_TEXTONLY]
dc_winalert("Please Wait Until the PDF file notification is closed. Press enter when completed to send Email")
endif

Sleep(10)



   cDialog := DC_WaitOn('Please Wait While Creating Email',,,,,,,,SetAppWindow(),SetAppWindow(),.t.)


  IF saPrintOptions[PRN_TEXTONLY] .and. 1=2  //always send as attachment for our testing
    IF !Empty(saPrintOptions[PRN_EMAILMEMO])
      cMemo := MemoTrim(saPrintOptions[PRN_EMAILMEMO]) + CRLF + CRLF
    ELSE
      cMemo := ''
    ENDIF
    cHeading := 'Here is the report you requested:' + CRLF + CRLF

    cText := cMemo + ;
             cHeading + ;
             MemoRead(saPrintOptions[PRN_TEMPFILE])
  ELSE
    cText := saPrintOptions[PRN_EMAILMEMO]
    cAttachment := saPrintOptions[PRN_TEMPFILE]
  ENDIF

  nSaveArea := Select()
  creplyto=""



  if SendMail( nil, nil, alltrim(saPrintOptions[PRN_EMAILTO]), ;
               cTitle, creplyto, cAttachment, cText, @cErrorText,"PRCHOICE" )
               DC_Impl(cDialog)


       MsgBox('Report has been sent via email to: ' + ;
              Alltrim(saPrintOptions[PRN_EMAILTO]))


  else
DC_Impl(cDialog)
       MsgBox('Email Failed. Report has not been sent via email to: ' + ;
              Alltrim(saPrintOptions[PRN_EMAILTO]))


  endif

endif
endif

FErase(saPrintOptions[PRN_TEMPFILE])



DC_PrinterObject(nil,.t.)


return (nil)

* -----------------

FUNCTION SendMail( cSMTPServer, cSender, cRecipient, cSubject, ;
                   cReplyTo, aAttachment, cText, cErrorText,zzFrom )

LOCAL oMail, oSender, oRecipient, oSmtp, lError := .t., cPrefix, ;
      cDefaultSMTPServer, cDefaultRecipient, cDefaultSender, aMailDef, ;
      aMailData, lSendMail := .F., nCode, cDiagFile, cCCList, cBCCList, i, ;
      cUserId, cPassword, cAttachment, cEmptyStr := Chr(0)

aMailDef := { 'SMTPServer', 'Recipient', 'Sender','UserName','Password' }
aMailData := { Space(100), Space(100), Space(100), Space(50), Space(50) }

nSaveArea := Select()

//dc_winalert("668")



select 0

//dc_winalert("694")
IF select( "Emailini")==0
        //dc_winalert("697")
use emailini
else
//     dc_winalert("700")
        select emailini
endif

lSecure=emailsec  //new for secure connection
cSMTPServer=emailserv
cSender=emailsend
cUserId=emailuser
cPassword=emailpass
cPort=emailport
if empty(creplyto) .and. !empty(emailreply)
//dc_winalert("706")
store alltrim(emailreply) to creplyto
endif

/*
nSmtpPort   = 587
cSmtpServer = "smtp04.domainlocalhost.com"
cSmtpUser   = "info@legacyfreight.net"
cSmtpPass   = "Truck#1"
cSmtpFrom   = "<info@legacyfreight.net>"
cSmtpTo     = "<fredh@omni-info.com>"


 */

use


//dc_winalert("710")

SELE (nSaveArea)
//dc_winalert("713")

cSMTPServer := Alltrim(cSMTPServer)
cRecipient := Alltrim(cRecipient)
cSender := Alltrim(cSender)
cUserId := Alltrim(cUserId)
cPassword := Alltrim(cPassword)

if empty(cReplyto)
   store cSender to cReplyto
endif
  //dc_winalert("724")
 if qqdetail="O" .or. qhwymstr="G"

 lError := .f.
 else
IF Empty(cSMTPServer)
  cErrortext := 'No SMTP Server Address'
ELSEIF Empty(cSender)
  cErrorText := 'No Sender Address'
ELSEIF Empty(cRecipient)
  cErrorText := 'No Recipient Address'
ELSEIF Empty(cSubject)
  cErrortext := 'No Subject'
ELSE
  lError := .f.
ENDIF
 endif
//dc_winalert("741")

IF lError
  //dcbdebug cErrorText PAUSE
dc_winalert("Email Set Up Error. "+cErrortext)
  RETURN .f.
ENDIF


//if zzfrom='PRCHOICE'  //NOT SURE WHY THIS WAS HERE, REMOVED IT.
//cText := '<pre>' + CRLF + cText + CRLF + '</pre>' + CRLF
//cText := Strtran(cText,Chr(13),Chr(13)+Chr(10))
//cText := Strtran(cText,Chr(13)+Chr(10)+Chr(10),Chr(13)+Chr(10))
//endif

//dc_winalert("748")

//#ifdef SENDMAIL_MARSHALLSOFT

  //dc_winalert(crecipient)
  //dc_winalert(aAttachment)

  //DEFAULT cReplyTo := cSender, ;


   DEFAULT cAttachment := aAttachment, ;
          cCCList := ccemail, ;
          cBCCList := bcemail
          //key_code=745874213
          //           key_code=0
          //new key code
          key_code=745874213
  cReplyTo := '<' + cReplyTo + '>'
  cSender := '<' + cSender + '>'
  if substr(cRecipient,1,1)<>"<"   //allows for special multiple recipients
        store crecipient to newr
        firsttime=.t.
        nnn=1
        do while .t.
                    nStart := at( ';', newr )
                if nstart=0
                        if firsttime
                        cRecipient := '<' + newr + '>'
                        exit
                        endif
                        n=1
                        cr2=""

                        store "E"+strzero(n,2) to eaddr
                        store &eaddr to cr2
                        n=n+1
                        do while n<nnn
                        store "E"+strzero(n,2) to eaddr
                        store cr2+';'+&eaddr to cr2
                        n=n+1
                        enddo
                        cRecipient := cr2+';'+'<' + newr + '>'

                        exit
                else
                store "E"+strzero(nnn,2) to eaddr
                store "<"+substr(newr,1,nstart-1)+">" to &eaddr
                newr=substr(newr,nstart+1)
                nnn=nnn+1
                endif


                firsttime=.f.

        enddo



  endif


/*
           dc_winalert(cAttachment)
  IF !Empty(aAttachment)
    FOR i := 1 TO Len(aAttachment)
      IF File(aAttachment[i])
        cAttachment += aAttachment[i] + IIF( i < Len(aAttachment),';','' )
      ENDIF
    NEXT
  ENDIF
           dc_winalert(cAttachment)
  */
  //if csmtpserver='smtp.gmail.com'
  if lsecure

  //verify stunnel exists
  //store '\oiswin\stunnel.exe' to sName
  //if !file(sname)
//        copy file \oiswin\backup\stunnel.bak to \oiswin\stunnel.exe
//  endif

  // run stunnel seeconnect.txt
   //RunShell('/c ','w:\oiswin\gostunnel.bat',,.t.)
   //dc_winalert('764')
  //DllCall(  "stunnel.dll seeconnect.txt", DLL_STDCALL )
//hprocess=DLLCALL("SEE32.DLL",DLL_STDCALL,"seeStartProgram",'Stunnel seeconnect.txt')
keyin=inkey(2)

//  hProcess = XseeStartProgram(@gostunnel)
  endif


   //dc_winalert(str(procline()))

  nCode := XseeAttach(1, SEE_KEY_CODE) // shareware version
  IF nCode < 0
   if lsecure
   //run stunnel seeconnect.txt
   //RunShell('/c ','\oiswin\stunnel -stop',,.t.)
   //RunShell('/c ','\oiswin\stunnel -exit',,.t.)
  //hProcess = XseeStartProgram(@cStunnel)
   //Code = XseeKillProgram(hProcess, 0)
  endif


   //Code = XseeKillProgram(hProcess, 0)
   //dc_winalert(str(procline()))
    RETURN .F.
  ENDIF
     //   dc_winalert(str(procline()))
  cDiagFile := 'EMAIL.LOG'






  //add path check here



//to ensure user is in proper folder for any attachments

 dc_chdir(subdef)

  /*

nCode = XseeStringParam(0, SEE_LOG_FILE, @cDiagFile)
* enable SMTP ("AUTH PLAIN" / "AUTH LOGIN" / "CRAM-MD5") authentication
nCode = XseeIntegerParam(0, SEE_ENABLE_ESMTP, 1)
nCode = XseeStringParam(0, SEE_SET_USER,    @cSmtpUser)
nCode = XseeStringParam(0, SEE_SET_SECRET,  @cSmtpPass)
* connect to SMTP server
? "Connecting to SMTP server " + cSmtpServer
nCode = XseeSmtpConnect(0, @cSmtpServer, @cSmtpFrom, @cSmtpReply)
if nCode < 0
  cTemp = SPACE(128)
  nCode = XseeErrorText(0,nCode,@cTemp,128)
  ? Left(cTemp,nCode)
else
  * send email message
  ? "Sending email to " + cSmtpTo
  nCode = XseeSendEmail(0,@cSmtpTo,@cEmptyStr,@cEmptyStr,@cSmtpSubj,@cSmtpMsg,@cEmptyStr)



   */




  if cport<>0
  nCode := XseeIntegerParam(0, SEE_SMTP_PORT, cport)
  endif

  if !lsecure
  nCode := XseeIntegerParam(0, SEE_ENABLE_ESMTP, AUTHENTICATE_PLAIN)

  endif




  //dc_winalert(str(procline()))
  //test return receipt here//
//ncode :=  xseeStringParam(0, SEE_ADD_HEADER,"Return-Receipt-To: <fredh@omni-info.com>")
//ncode :=  xseeStringParam(0, SEE_ADD_HEADER,"Disposition-Notification-To: <fredh@omni-info.com>")


  * Enable quoting
  nCode := XseeIntegerParam(0, SEE_QUOTED_PRINTABLE, QUOTED_PLAIN)
  * connect to SMTP server
  if !lsecure
  nCode := XseeStringParam(0, SEE_SET_USER,    @cUserId)
  nCode := XseeStringParam(0, SEE_SET_SECRET,  @cPassword)
  endif


   nProxyPort = 8801
   //nProxyPort = 0
   cProxyDir = "\oiswin"
   cProxyExe = "stunnel.exe"
   cProxyCert = "stunnel.pem"
   nFlags = 1




  //nProxyport=8001
  store cReplyto to cSender  //for mobile this is required
  //nCode = XseeSmtpConnectSSL(0, nProxyPort, @cSmtpUser, @cSmtpPass, @cSmtpFrom, @cSmtpReply)
  if lsecure

            cOptions = "debug=0" + chr(0)
            nCode = XseeConfigSSL(SSL_CONFIG_OPTIONS, @cOptions)

   Kode = XseeSetProxySSL(0, nFlags, @cProxyDir, @cProxyCert, @cProxyExe)   //newv version


   nCode = XseeSmtpConnectSSL(0, nProxyPort, cPort, @cSmtpServer, @cUserid, @cPassword, @cSender, @cReplyto, Chr(0))  ///new version


  else
  nCode := XseeSmtpConnect(0, @cSMTPServer, @cSender, @cReplyTo)
  endif


  IF nCode < 0
    cErrorText := SPACE(128)
    nCode := XseeErrorText(0,nCode,@cErrorText,128)
   if lsecure
   //run stunnel seeconnect.txt
   //RunShell('/c ','\oiswin\stunnel -stop',,.t.)
   //RunShell('/c ','\oiswin\stunnel -exit',,.t.)
  //hProcess = XseeStartProgram(@cStunnel)
   //Code = XseeKillProgram(hProcess, 0)
  endif

  //dc_winalert(str(procline()))
  ELSE
    * send email message
    Sleep(10)

        nCode := XseeSendEmail(0,@cRecipient,@cCCList,@cBCClist,@cSubject,@cText,@cAttachment)
    IF nCode < 0
      cErrorText := SPACE(128)
      nCode := XseeErrorText(0,nCode,@cErrorText,128)

   if lsecure
   //run stunnel seeconnect.txt
   //RunShell('/c ','\oiswin\stunnel -stop',,.t.)
   //RunShell('/c ','\oiswin\stunnel -exit',,.t.)
  //hProcess = XseeStartProgram(@cStunnel)
   //Code = XseeKillProgram(hProcess, 0)
  endif


    ELSE
      lError := .F.
    ENDIF
  ENDIF
  nCode := XseeClose(0)
  nCode := XseeRelease()
   if lsecure
   //run stunnel seeconnect.txt
   //RunShell('/c ','\oiswin\stunnel -stop',,.t.)
   //RunShell('/c ','\oiswin\stunnel -exit',,.t.)
  //hProcess = XseeStartProgram(@cStunnel)
   //Code = XseeKillProgram(hProcess, 0)
  endif

  //dc_winalert(str(procline()))
//#endif
//dc_winalert(str(ncode))
IF !Empty(cErrorText)
  //dcbdebug cErrorText
//if localx="E"
        dc_winalert(cErrortext)
//endif

  lError := .T.
  //dc_winalert(str(procline()))
ENDIF
//Code = XseeKillProgram(hProcess, 0)
RETURN !lError

* -----------------

FUNCTION EmailSetup()

LOCAL GetList[0], GetOptions, cSMTPServer := '', cSMTPRecipient := '', ;
      cSMTPSender := '', cSMTPUserName := '', cSMTPPassword := '', aData, ;
      aRef, lStatus

// Load [SENDMAIL] group of EMAIL.INI

aRef := { ;
  'SMTPServer', ;
  'Recipient', ;
  'Sender', ;
  'UserName', ;
  'Password' }

aData := { ;
  Pad(cSMTPServer,100), ;
  Pad(cSMTPRecipient,100), ;
  Pad(cSMTPSender,100), ;
  Pad(cSMTPUserName,30), ;
  Pad(cSMTPPassword,30) }

DC_IniLoad('EMAIL.INI','SENDMAIL',aData, aRef)

cSMTPServer := aData[1]
cSMTPRecipient := aData[2]
cSMTPSender := aData[3]
cSMTPUserName := aData[4]
cSMTPPassword := aData[5]

@ 1,2 DCSAY 'Server Name' GET cSMTPServer GETSIZE 60 ;
         TOOLTIP 'Server fully qualified name or IP address'

@ 2,2 DCSAY 'Recipient Email' GET cSMTPRecipient GETSIZE 60 ;
         TOOLTIP 'Email Address of DEFAULT recipient'

@ 3,2 DCSAY 'Sender Email' GET cSMTPSender GETSIZE 60 ;
         TOOLTIP 'Email Address of DEFAULT sender'

@ 4,2 DCSAY 'User Name' GET cSMTPUserName ;
         TOOLTIP 'User Name or ID for SMTP Login Authentication'

@ 5,2 DCSAY 'Password' GET cSMTPPassword ;
         TOOLTIP 'Password for SMTP Login Authentication' PASSWORD

DCGETOPTIONS ;
   SAYRIGHTBOTTOM ;
   SAYWIDTH 120 ;
   TABSTOP

DCREAD GUI ;
   FIT ;
   OPTIONS GetOptions ;
   ADDBUTTONS ;
   TITLE 'E-Mail Setup' ;
   MODAL ;
   TO lStatus

IF lStatus

  aData := { ;
   cSMTPServer, ;
   cSMTPRecipient, ;
   cSMTPSender, ;
   cSMTPUserName, ;
   cSMTPPassword }

  DC_IniSave('EMAIL.INI','SENDMAIL',aData, aRef)

ENDIF

RETURN nil

* -----------------

FUNCTION YesNoBox( cHeader, cTitle, aMessage, nWidth, nChoice )

LOCAL GetList[0], GetOptions, nRow := 1, lStatus, aButtons, i

DEFAULT nWidth := 60, ;
        nChoice := 1

IF Valtype(aMessage) = 'C'
  aMessage := { aMessage }
ENDIF

@ nRow++, 1 DCSAY cHeader SAYSIZE nWidth, 1.2 SAYCENTER FONT '11.Arial Bold'
@ nRow++, 1 DCSTATIC TYPE XBPSTATIC_TYPE_RAISEDBOX SIZE nWidth, .1
FOR i := 1 TO Len(aMessage)
  @ nRow++, 1 DCSAY aMessage[i] SAYSIZE nWidth SAYCENTER
NEXT

aButtons := { ;
   {'~Yes',70,22,{||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}}, ;
   {'~No',70,22,{||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)}} }

DCGETOPTIONS ;
   NORESIZE ;
   NOMINBUTTON ;
   NOMAXBUTTON ;
   BUTTONS aButtons ;
   BUTTONALIGN DCGUI_BUTTONALIGN_CENTER

DCREAD GUI ;
   FIT ;
   OPTIONS GetOptions ;
   TITLE cTitle ;
   MODAL ;
   SETFOCUS IIF(nChoice==1,'DCGUI_BUTTON_CUSTOM_1','DCGUI_BUTTON_CUSTOM_2') ;
   SETAPPWINDOW ;
   TO lStatus ;
   TIMEOUT 300

return lStatus

* ----------------

FUNCTION MemoTrim( cMemo, cQuote, cEndofLine, cBlankLine, lTrim )

LOCAL cOut := '', cLine, nLines, i

cQuote     := IIF(Valtype(cQuote)='C',cQuote,'')
cEndofLine := IIF(Valtype(cEndofLine)='C',cEndofLine,'')
cBlankLine := IIF(Valtype(cBlankLine)='C',cBlankLine,'')
lTrim      := IIF(Valtype(lTrim)='L',lTrim,.f.)

nLines := MLCOUNT(cMemo)
FOR i := nLines TO 1 STEP -1
  IF !EMPTY(TRIM(MEMOLINE(cMemo,,i)))
    EXIT
  ENDIF
NEXT
nLines := i
FOR i := 1 TO nLines
  cLine := TRIM( MEMOLINE( cMemo,, i ) )
  IF lTrim
    cLine := AllTrim(cLine)
  ENDIF
  IF Empty(cLine)
    cLine := cBlankLine
  ENDIF
  IF EMPTY(cLine) .AND. i=nLines
    EXIT
  ENDIF
  cLine := cLine + cEndofLine + CHR(13) +CHR(10)
  cOut := cOut + cQuote + cLine
NEXT
RETURN cOut


FUNCTION DC_PrinterOxx ( oPrinter, nPage, lOkCancel )

LOCAL oThread, lStatus := .t.

oPrinter := DC_PrinterObject( oPrinter )

IF Valtype(oPrinter) = 'O' .AND. !oPrinter:lExcel

  oPrinter:lDone := .t.
  IF oPrinter:lPreview .AND. !Empty(oPrinter:aBuffer)
    oPrinter:nLastPage := Len(oPrinter:aBuffer)
    IF Valtype(nPage) == 'N'
      oPrinter:nCurrPage := nPage
    ELSEIF !oPrinter:oDlg:isVisible()
      oPrinter:nCurrPage := 1
    ELSE
      oPrinter:nCurrPage := Len(oPrinter:aBuffer)
    ENDIF
    IF oPrinter:oOkButton:nShortCut != NIL
      SetAppEvent( oPrinter:oOkButton:nShortCut, )
    ENDIF
    oPrinter:odlg:setFrameState(XBPDLG_FRAMESTAT_MAXIMIZED)
    oPrinter:oOKButton:SetShortCut()
; //    _HotKey(oPrinter:oOkButton:caption,oPrinter:oOkButton,oPrinter:aHotKeys)
    oPrinter:lStopEject := .t.
    oPrinter:eject()
  ENDIF

  oPrinter:Destroy()

  IF oPrinter:lAcrobat
    IF DC_PrintPreviewAcrobatOpt()[1] == 1
      oThread := Thread():new()
      Sleep(10)
      oThread:start({||DC_PrintPreviewAcrobat(oPrinter:cOutFile,oPrinter:cTitle,lOkCancel)})
    ELSE
      lStatus := DC_PrintPreviewAcrobat(oPrinter:cOutFile,oPrinter:cTitle,lOkCancel)
    ENDIF
  ENDIF

ELSEIF Valtype(oPrinter) == 'O' .AND. oPrinter:lExcel





  DC_Array2Excel(@oPrinter:cOutfile, oPrinter:aExcelSheet,,.t.,.f.,.f.,.t., oPrinter:lCombineSheets )

  DC_SpawnUrl(oPrinter:cOutFile)

ENDIF

IF Valtype(oPrinter) == 'O' .AND. Valtype(oPrinter:oBullZip) == 'O'
  oPrinter:oBullZip:destroy()
ENDIF


RETURN lStatus



FUNCTION DC_PrinterOzz ( oPrinter, nPage, lOkCancel )

LOCAL oThread, lStatus := .t.

oPrinter := DC_PrinterObject( oPrinter )

IF Valtype(oPrinter) = 'O'
  oPrinter:lDone := .t.
  IF oPrinter:lPreview .AND. !Empty(oPrinter:aBuffer)
    oPrinter:nLastPage := Len(oPrinter:aBuffer)
    IF Valtype(nPage) == 'N'
      oPrinter:nCurrPage := nPage
    ELSEIF !oPrinter:oDlg:isVisible()
      oPrinter:nCurrPage := 1
    ELSE
      oPrinter:nCurrPage := Len(oPrinter:aBuffer)
    ENDIF
    IF oPrinter:oOkButton:nShortCut != NIL
      SetAppEvent( oPrinter:oOkButton:nShortCut, )
    ENDIF
     oPrinter:odlg:setFrameState(XBPDLG_FRAMESTAT_MAXIMIZED)
    ; //oPrinter:oOkButton:setCaption(DC_LangMsg(DCMSG_EXIT))
    oPrinter:oOKButton:SetShortCut()
    ; //_HotKey(oPrinter:oOkButton:caption,oPrinter:oOkButton,oPrinter:aHotKeys)
    oPrinter:lStopEject := .t.
    oPrinter:eject()

  ENDIF

  oPrinter:Destroy()

  IF oPrinter:lAcrobat
    IF DC_PrintPreviewAcrobatOpt()[1] == 1
      oThread := Thread():new()
      Sleep(10)
      oThread:start({||DC_PrintPreviewAcrobat(oPrinter:cOutFile,oPrinter:cTitle,lOkCancel)})
    ELSE
      lStatus := DC_PrintPreviewAcrobat(oPrinter:cOutFile,oPrinter:cTitle,lOkCancel)
    ENDIF
  ENDIF
ENDIF
RETURN lStatus
Static Function Loadpdf(getlist2)

LOCAL GetList := {}, GetOptions

installok=.f.

@ 1,1 dcsay "Win2PDF is a printer driver that will create Acrobat PDF files when printing " saysize 0 sayleftbottom
@ 2,1 dcsay "and invoke the Acrobat Reader as the print previewer." saysize 0 sayleftbottom

@ 4,1 dcsay "The W2PDS184.EXE file is an install program which will install the demo" saysize 0 sayleftbottom
@ 5,1 dcsay "version on your computer.  This works only on Windows NT, 2000 and XP"   saysize 0 sayleftbottom
@ 6,1 dcsay "operating systems.  Go to http://www.daneprarie.com for more information on" saysize 0 sayleftbottom
@ 7,1 dcsay "purchasing an inexpensive license." saysize 0 sayleftbottom

@ 9,1 dcsay "Go to http://www.adobe.com to download the latest version of Acrobat reader." saysize 0 sayleftbottom
@ 10,1 dcsay "The DCPRINT system requires version 5.0 or later.  Acrobat reader is FREE."  saysize 0 sayleftbottom

@ 12,01 dccheckbox installok prompt "Install Win2PDF"

DCGETOPTIONS NORESIZE  COLOR &QQfour NOMINBUTTON NOMAXBUTTON tabstop;
SAYBOTTOM

DCREAD GUI FIT  TO Okx ENTEREXIT Addbuttons ;
Setappwindow ;
options getoptions Modal

if !Okx .or. !installok
   pdfinstall =.f.
   dc_getrefresh(getlist2)
   return nil
 endif


//install win2pdf now
RunShell('/c','\express\win2pdf\w2pdf_setup.exe',,.t.)
  pdfinstall =.f.
   dc_getrefresh(getlist2)
 return nil

Static Function Upemail(getlist2)

LOCAL GetList := {}, GetOptions

nSaveArea := Select()
store space(50) to eServer
store space(50) to eSender
store space(20) to eUser
store space(20) to ePass


select 0
use emailini
if .not. eof()
store emailserv to eServer
store emailsend to eSender
store emailuser to eUser
store emailpass to ePass
endif

@ 01,01 dcsay "Email Server "get eserver  saysize 15 sayrightbottom
@ 02,01 dcsay "Email Address" get esender saysize 15 sayrightbottom
@ 03,01 dcsay "User Name " get eUser  saysize 15 sayrightbottom
@ 04,01 dcsay "Password "get ePass    saysize 15 sayrightbottom


DCGETOPTIONS NORESIZE  COLOR &QQfour NOMINBUTTON NOMAXBUTTON tabstop;


DCREAD GUI FIT  TO Okx ENTEREXIT Addbuttons ;
options getoptions Modal

if !Okx
   select emailini
   use
   setemail=.f.
   dc_getrefresh(getlist2)
   return nil
endif



if eof()
   append blank
else
   oisrclck()
endif
replace emailserv with eServer
replace emailsend with eSender
replace emailuser with eUser
replace emailpass with ePass
replace emailrec with 'support@omni-info.com'  //omni support
oisunlck()

noemail=.f.
setemail=.f.
dc_getrefresh(getlist2)
use
SELE (nSaveArea)

return nil





